View Issue Details

IDProjectCategoryView StatusLast Update
0017090LazarusWidgetsetpublic2011-12-01 11:24
ReporterFelipe Monteiro de CarvalhoAssigned ToFelipe Monteiro de Carvalho 
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
Product VersionProduct Build 
Target VersionFixed in Version0.9.29 (SVN) 
Summary0017090: Misc WinCE Menu issues
DescriptionSee bug report 16435 for reference
Tagswince
Fixed in Revision26986, 26990
LazTarget-
WidgetsetWinCE
Attached Files

Relationships

related to 0016435 closedFelipe Monteiro de Carvalho Cannot change caption of MainMenuItem if Item has subitem, WinCE 

Activities

Felipe Monteiro de Carvalho

2010-08-02 23:05

developer   ~0039902

test, ok, no Mantis bug

John vd Waeter

2010-08-03 08:48

reporter   ~0039916

Yes, but isn't it strange that the Captions of the menus do get updated?

Felipe Monteiro de Carvalho

2010-08-03 09:49

developer   ~0039922

Last edited: 2010-08-03 09:54

Probably WinCE automatically does that, but we also have an internal list linking menu IDs to LCL Menu items, it won't update that list. The list needs necessarely to be updated because the menu IDs for all forms are the same ones. I added recreation of the menu upon receiving WM_ACTIVATE in a form. Please try again after rev 26986

John vd Waeter

2010-08-03 09:59

reporter   ~0039926

I've svn updated to rev 26987, but the problem persists. I see no changes.

Felipe Monteiro de Carvalho

2010-08-03 10:15

developer   ~0039930

Very strange, with which emulator version? I didn't fix the 6.5 issue

John vd Waeter

2010-08-03 10:17

reporter   ~0039931

I tried WM 5 pocketpc and WM 5 smartphone.

Felipe Monteiro de Carvalho

2010-08-03 10:19

developer   ~0039932

Last edited: 2010-08-03 10:26

Test project? Here it works. And it would be great if it was called testmenu5. I am building a test suite for wince menus and there is already testmenu1,2,3,4

Felipe Monteiro de Carvalho

2010-08-03 10:38

developer   ~0039935

Actually here using the WM 6.5 Professional emulator all my test cases work!

2010-08-03 10:38

 

testmenu5.zip (66,872 bytes)

John vd Waeter

2010-08-03 10:42

reporter   ~0039936

On my 6.5 emulator the menu on Form1 even initially does not work.
Please find testmenu5.zip.
I really have doubts about svn update. The Lazarus Help says I'm at revision 26987, but I really like to check the source for changes you made. Maybe for some reason it is not included in the rebuild, so I'd like to peek into the source...

Felipe Monteiro de Carvalho

2010-08-03 10:44

developer   ~0039938

The only bug I note in testmenu5 is that the "Back" button in Form 2 doesn't work in WM 5 atKeyPadDevice. Everything else works. Maybe you forgot to rebuild LCL or the application? Or maybe you need to clean+build LCL

Felipe Monteiro de Carvalho

2010-08-03 10:45

developer   ~0039939

You can check my changes in this page: http://svn.freepascal.org/cgi-bin/viewvc.cgi?view=rev&root=lazarus&revision=26986

2010-08-03 10:49

 

wince_menutest5_wm65.PNG (68,831 bytes)
wince_menutest5_wm65.PNG (68,831 bytes)

John vd Waeter

2010-08-03 11:05

reporter   ~0039942

Ok, rebuilt LCL and now it works OK on WM5 PocketPC, WM6.1 PocketPC.

Not OK on WM 5 Keypaddevice (Back menu doesn't work as you already said)

Not OK on WM 6.5 VGA (or label1 on both form1 and form2 is not updated?)

John vd Waeter

2010-08-03 11:09

reporter   ~0039943

Lovely MS introduces differences in 6.5 between Professional 240x320) and Professional-VGA (480x640)....

John vd Waeter

2010-08-03 11:13

reporter   ~0039944

I must add that on my htc HD2 (480x800, wm 6.5) the menu appears quite different then on the 6.5 VGa emulator. It probably has something to do with the HD2 not being able to respond to fine pen-ticks. You have to use a finger, which is inaccurate. htc seems to intercept the menu-handling and presents a menu that is screen-wide and a lot bigger, so easier to control with a finger. MS probably provided a hook to do so... maybe this hook interferes with your code?

Felipe Monteiro de Carvalho

2010-08-03 11:28

developer   ~0039945

Instead of writing to the label, just write to the window caption. It works. The "Back" menu also works. AFAIK menus work perfectly in WM 6.5 VGA. The bug is in label drawing, and therefore not menu related. It would be good if you open a new issue for that and here we focus only in menus.

John vd Waeter

2010-08-03 11:34

reporter   ~0039949

Ok, confirmed.
That leaves only the back-button on the keypaddevice.

Felipe Monteiro de Carvalho

2010-08-03 12:10

developer   ~0039951

I found the bug! TStringList.Find only works in sorted lists ... I didn't know about that was using it wrong. Try again with rev > 26990

John vd Waeter

2010-08-03 12:59

reporter   ~0039952

Last edited: 2010-08-03 13:27

:-) Looks good, no problems on 6 emulators!

PLUS ok on the real device hd2!

Felipe Monteiro de Carvalho

2010-08-03 13:39

developer   ~0039953

Great =) You can reopen the bug or start a new one if you find any new issue.

Issue History

Date Modified Username Field Change
2010-08-02 23:03 Felipe Monteiro de Carvalho New Issue
2010-08-02 23:03 Felipe Monteiro de Carvalho LazTarget => -
2010-08-02 23:03 Felipe Monteiro de Carvalho Widgetset => WinCE
2010-08-02 23:04 Felipe Monteiro de Carvalho Relationship added related to 0016435
2010-08-02 23:04 Felipe Monteiro de Carvalho Status new => assigned
2010-08-02 23:04 Felipe Monteiro de Carvalho Assigned To => Felipe Monteiro de Carvalho
2010-08-02 23:05 Felipe Monteiro de Carvalho Note Added: 0039902
2010-08-03 08:48 John vd Waeter Note Added: 0039916
2010-08-03 09:49 Felipe Monteiro de Carvalho Note Added: 0039922
2010-08-03 09:54 Felipe Monteiro de Carvalho Note Edited: 0039922
2010-08-03 09:59 John vd Waeter Note Added: 0039926
2010-08-03 10:15 Felipe Monteiro de Carvalho Note Added: 0039930
2010-08-03 10:17 John vd Waeter Note Added: 0039931
2010-08-03 10:19 Felipe Monteiro de Carvalho Note Added: 0039932
2010-08-03 10:26 Felipe Monteiro de Carvalho Note Edited: 0039932
2010-08-03 10:38 Felipe Monteiro de Carvalho Note Added: 0039935
2010-08-03 10:38 John vd Waeter File Added: testmenu5.zip
2010-08-03 10:42 John vd Waeter Note Added: 0039936
2010-08-03 10:44 Felipe Monteiro de Carvalho Note Added: 0039938
2010-08-03 10:45 Felipe Monteiro de Carvalho Note Added: 0039939
2010-08-03 10:49 Felipe Monteiro de Carvalho File Added: wince_menutest5_wm65.PNG
2010-08-03 11:05 John vd Waeter Note Added: 0039942
2010-08-03 11:09 John vd Waeter Note Added: 0039943
2010-08-03 11:13 John vd Waeter Note Added: 0039944
2010-08-03 11:28 Felipe Monteiro de Carvalho Note Added: 0039945
2010-08-03 11:34 John vd Waeter Note Added: 0039949
2010-08-03 12:10 Felipe Monteiro de Carvalho Note Added: 0039951
2010-08-03 12:59 John vd Waeter Note Added: 0039952
2010-08-03 13:27 John vd Waeter Note Edited: 0039952
2010-08-03 13:39 Felipe Monteiro de Carvalho Fixed in Revision => 26986, 26990
2010-08-03 13:39 Felipe Monteiro de Carvalho Status assigned => resolved
2010-08-03 13:39 Felipe Monteiro de Carvalho Fixed in Version => 0.9.29 (SVN)
2010-08-03 13:39 Felipe Monteiro de Carvalho Resolution open => fixed
2010-08-03 13:39 Felipe Monteiro de Carvalho Note Added: 0039953
2010-09-26 01:16 Zaher Dirkey Tag Attached: wince
2011-12-01 11:24 Marc Weustink Status resolved => closed